package dev.shadowsoffire.apotheosis.advancements;

import net.minecraft.advancements.critereon.SerializationContext;
import net.minecraft.advancements.critereon.AbstractCriterionTriggerInstance;
import net.minecraft.world.item.ItemStack;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.advancements.critereon.MinMaxBounds;
import net.minecraft.advancements.critereon.ItemPredicate;
import net.minecraft.advancements.critereon.DeserializationContext;
import net.minecraft.advancements.critereon.ContextAwarePredicate;
import com.google.gson.JsonObject;
import net.minecraft.advancements.critereon.EnchantedItemTrigger;

public class EnchantedTrigger extends EnchantedItemTrigger
{
    public Instance createInstance(final JsonObject json, final ContextAwarePredicate entityPredicate, final DeserializationContext conditionsParser) {
        final ItemPredicate item = ItemPredicate.m_45051_(json.get("item"));
        final MinMaxBounds.Ints levels = MinMaxBounds.Ints.m_55373_(json.get("levels"));
        final MinMaxBounds.Doubles eterna = MinMaxBounds.Doubles.m_154791_(json.get("eterna"));
        final MinMaxBounds.Doubles quanta = MinMaxBounds.Doubles.m_154791_(json.get("quanta"));
        final MinMaxBounds.Doubles arcana = MinMaxBounds.Doubles.m_154791_(json.get("arcana"));
        final MinMaxBounds.Doubles rectification = MinMaxBounds.Doubles.m_154791_(json.get("rectification"));
        return new Instance(item, levels, eterna, quanta, arcana, rectification);
    }
    
    public void trigger(final ServerPlayer player, final ItemStack stack, final int level, final float eterna, final float quanta, final float arcana, final float rectification) {
        this.m_66234_(player, inst -> {
            if (inst instanceof final Instance instance) {
                return instance.test(stack, level, eterna, quanta, arcana, rectification);
            }
            else {
                return inst.m_27691_(stack, level);
            }
        });
    }
    
    public static class Instance extends EnchantedItemTrigger.TriggerInstance
    {
        protected final MinMaxBounds.Doubles eterna;
        protected final MinMaxBounds.Doubles quanta;
        protected final MinMaxBounds.Doubles arcana;
        protected final MinMaxBounds.Doubles rectification;
        
        public Instance(final ItemPredicate item, final MinMaxBounds.Ints levels, final MinMaxBounds.Doubles eterna, final MinMaxBounds.Doubles quanta, final MinMaxBounds.Doubles arcana, final MinMaxBounds.Doubles rectification) {
            super(ContextAwarePredicate.f_285567_, item, levels);
            this.eterna = eterna;
            this.quanta = quanta;
            this.arcana = arcana;
            this.rectification = rectification;
        }
        
        public static EnchantedItemTrigger.TriggerInstance any() {
            return new EnchantedItemTrigger.TriggerInstance(ContextAwarePredicate.f_285567_, ItemPredicate.f_45028_, MinMaxBounds.Ints.f_55364_);
        }
        
        public boolean test(final ItemStack stack, final int level, final float eterna, final float quanta, final float arcana, final float rectification) {
            return super.m_27691_(stack, level) && this.eterna.m_154810_((double)eterna) && this.quanta.m_154810_((double)quanta) && this.arcana.m_154810_((double)arcana) && this.rectification.m_154810_((double)rectification);
        }
        
        public boolean m_27691_(final ItemStack stack, final int level) {
            return this.test(stack, level, 0.0f, 0.0f, 0.0f, 0.0f);
        }
        
        public JsonObject m_7683_(final SerializationContext serializer) {
            final JsonObject jsonobject = super.m_7683_(serializer);
            jsonobject.add("eterna", this.eterna.m_55328_());
            jsonobject.add("quanta", this.quanta.m_55328_());
            jsonobject.add("arcana", this.arcana.m_55328_());
            jsonobject.add("rectification", this.rectification.m_55328_());
            return jsonobject;
        }
    }
}
